	.syntax	unified

	.section .text.vect

	.global	VectTable

VectTable:
	.word		__stack_init

	.word		Reset_Handler
	.weak		Reset_Handler
	.thumb_set	Reset_Handler, Undefined_Handler

	.word		NMI_Handler
	.weak		NMI_Handler
	.thumb_set	NMI_Handler, Undefined_Handler

	.word		HardFault_Handler
	.weak		HardFault_Handler
	.thumb_set	HardFault_Handler, Undefined_Handler

	/*---------------*/
	/* offset 0x0010 */
	/*---------------*/
	.word		MemManage_Handler
	.weak		MemManage_Handler
	.thumb_set	MemManage_Handler, Undefined_Handler

	.word		BusFault_Handler
	.weak		BusFault_Handler
	.thumb_set	BusFault_Handler, Undefined_Handler

	.word		UsageFault_Handler
	.weak		UsageFault_Handler
	.thumb_set	UsageFault_Handler, Undefined_Handler

	.word		0

	/*---------------*/
	/* offset 0x0020 */
	/*---------------*/
	.word		0

	.word		0

	.word		0

	.word		SVC_Handler
	.weak		SVC_Handler
	.thumb_set	SVC_Handler, Undefined_Handler

	/*---------------*/
	/* offset 0x0030 */
	/*---------------*/
	.word		DebugMon_Handler
	.weak		DebugMon_Handler
	.thumb_set	DebugMon_Handler, Undefined_Handler

	.word		0

	.word		PendSV_Handler
	.weak		PendSV_Handler
	.thumb_set	PendSV_Handler, Undefined_Handler

	.word		SysTick_Handler
	.weak		SysTick_Handler
	.thumb_set	SysTick_Handler, Undefined_Handler

	/*---------------*/
	/* offset 0x0040 */
	/*---------------*/
	.word		WWDG_IRQHandler
	.weak		WWDG_IRQHandler
	.thumb_set	WWDG_IRQHandler, Undefined_Handler

	.word		PVD_IRQHandler
	.weak		PVD_IRQHandler
	.thumb_set	PVD_IRQHandler, Undefined_Handler

	.word		TAMPER_STAMP_IRQHandler
	.weak		TAMPER_STAMP_IRQHandler
	.thumb_set	TAMPER_STAMP_IRQHandler, Undefined_Handler

	.word		RTC_WKUP_IRQHandler
	.weak		RTC_WKUP_IRQHandler
	.thumb_set	RTC_WKUP_IRQHandler, Undefined_Handler

	/*---------------*/
	/* offset 0x0050 */
	/*---------------*/
	.word		FLASH_IRQHandler
	.weak		FLASH_IRQHandler
	.thumb_set	FLASH_IRQHandler, Undefined_Handler

	.word		RCC_IRQHandler
	.weak		RCC_IRQHandler
	.thumb_set	RCC_IRQHandler, Undefined_Handler

	.word		EXTI0_IRQHandler
	.weak		EXTI0_IRQHandler
	.thumb_set	EXTI0_IRQHandler, Undefined_Handler

	.word		EXTI1_IRQHandler
	.weak		EXTI1_IRQHandler
	.thumb_set	EXTI1_IRQHandler, Undefined_Handler

	/*---------------*/
	/* offset 0x0060 */
	/*---------------*/
	.word		EXTI2_TS_IRQHandler
	.weak		EXTI2_TS_IRQHandler
	.thumb_set	EXTI2_TS_IRQHandler, Undefined_Handler

	.word		EXTI3_IRQHandler
	.weak		EXTI3_IRQHandler
	.thumb_set	EXTI3_IRQHandler, Undefined_Handler

	.word		EXTI4_IRQHandler
	.weak		EXTI4_IRQHandler
	.thumb_set	EXTI4_IRQHandler, Undefined_Handler

	.word		DMA1_Channel1_IRQHandler
	.weak		DMA1_Channel1_IRQHandler
	.thumb_set	DMA1_Channel1_IRQHandler, Undefined_Handler

	/*---------------*/
	/* offset 0x0070 */
	/*---------------*/
	.word		DMA1_Channel2_IRQHandler
	.weak		DMA1_Channel2_IRQHandler
	.thumb_set	DMA1_Channel2_IRQHandler, Undefined_Handler

	.word		DMA1_Channel3_IRQHandler
	.weak		DMA1_Channel3_IRQHandler
	.thumb_set	DMA1_Channel3_IRQHandler, Undefined_Handler

	.word		DMA1_Channel4_IRQHandler
	.weak		DMA1_Channel4_IRQHandler
	.thumb_set	DMA1_Channel4_IRQHandler, Undefined_Handler

	.word		DMA1_Channel5_IRQHandler
	.weak		DMA1_Channel5_IRQHandler
	.thumb_set	DMA1_Channel5_IRQHandler, Undefined_Handler

	/*---------------*/
	/* offset 0x0080 */
	/*---------------*/
	.word		DMA1_Channel6_IRQHandler
	.weak		DMA1_Channel6_IRQHandler
	.thumb_set	DMA1_Channel6_IRQHandler, Undefined_Handler

	.word		DMA1_Channel7_IRQHandler
	.weak		DMA1_Channel7_IRQHandler
	.thumb_set	DMA1_Channel7_IRQHandler, Undefined_Handler

	.word		ADC1_IRQHandler
	.weak		ADC1_IRQHandler
	.thumb_set	ADC1_IRQHandler, Undefined_Handler

	.word		CAN1_TX_IRQHandler
	.weak		CAN1_TX_IRQHandler
	.thumb_set	CAN1_TX_IRQHandler, Undefined_Handler

	/*---------------*/
	/* offset 0x0090 */
	/*---------------*/
	.word		CAN1_RX0_IRQHandler
	.weak		CAN1_RX0_IRQHandler
	.thumb_set	CAN1_RX0_IRQHandler, Undefined_Handler

	.word		CAN1_RX1_IRQHandler
	.weak		CAN1_RX1_IRQHandler
	.thumb_set	CAN1_RX1_IRQHandler, Undefined_Handler

	.word		CAN1_SCE_IRQHandler
	.weak		CAN1_SCE_IRQHandler
	.thumb_set	CAN1_SCE_IRQHandler, Undefined_Handler

	.word		EXTI9_5_IRQHandler
	.weak		EXTI9_5_IRQHandler
	.thumb_set	EXTI9_5_IRQHandler, Undefined_Handler

	/*---------------*/
	/* offset 0x00A0 */
	/*---------------*/
	.word		TIM15_IRQHandler
	.weak		TIM15_IRQHandler
	.thumb_set	TIM15_IRQHandler, Undefined_Handler

	.word		TIM16_IRQHandler
	.weak		TIM16_IRQHandler
	.thumb_set	TIM16_IRQHandler, Undefined_Handler

	.word		TIM17_IRQHandler
	.weak		TIM17_IRQHandler
	.thumb_set	TIM17_IRQHandler, Undefined_Handler

	.word		TIM18_DAC2_IRQHandler
	.weak		TIM18_DAC2_IRQHandler
	.thumb_set	TIM18_DAC2_IRQHandler, Undefined_Handler

	/*---------------*/
	/* offset 0x00B0 */
	/*---------------*/
	.word		TIM2_IRQHandler
	.weak		TIM2_IRQHandler
	.thumb_set	TIM2_IRQHandler, Undefined_Handler

	.word		TIM3_IRQHandler
	.weak		TIM3_IRQHandler
	.thumb_set	TIM3_IRQHandler, Undefined_Handler

	.word		TIM4_IRQHandler
	.weak		TIM4_IRQHandler
	.thumb_set	TIM4_IRQHandler, Undefined_Handler

	.word		I2C1_EV_IRQHandler
	.weak		I2C1_EV_IRQHandler
	.thumb_set	I2C1_EV_IRQHandler, Undefined_Handler

	/*---------------*/
	/* offset 0x00C0 */
	/*---------------*/
	.word		I2C1_ER_IRQHandler
	.weak		I2C1_ER_IRQHandler
	.thumb_set	I2C1_ER_IRQHandler, Undefined_Handler

	.word		I2C2_EV_IRQHandler
	.weak		I2C2_EV_IRQHandler
	.thumb_set	I2C2_EV_IRQHandler, Undefined_Handler

	.word		I2C2_ER_IRQHandler
	.weak		I2C2_ER_IRQHandler
	.thumb_set	I2C2_ER_IRQHandler, Undefined_Handler

	.word		SPI1_IRQHandler
	.weak		SPI1_IRQHandler
	.thumb_set	SPI1_IRQHandler, Undefined_Handler

	/*---------------*/
	/* offset 0x00D0 */
	/*---------------*/
	.word		SPI2_IRQHandler
	.weak		SPI2_IRQHandler
	.thumb_set	SPI2_IRQHandler, Undefined_Handler

	.word		USART1_IRQHandler
	.weak		USART1_IRQHandler
	.thumb_set	USART1_IRQHandler, Undefined_Handler

	.word		USART2_IRQHandler
	.weak		USART2_IRQHandler
	.thumb_set	USART2_IRQHandler, Undefined_Handler

	.word		USART3_IRQHandler
	.weak		USART3_IRQHandler
	.thumb_set	USART3_IRQHandler, Undefined_Handler

	/*---------------*/
	/* offset 0x00E0 */
	/*---------------*/
	.word		EXTI15_10_IRQHandler
	.weak		EXTI15_10_IRQHandler
	.thumb_set	EXTI15_10_IRQHandler, Undefined_Handler

	.word		RTC_Alarm_IRQHandler
	.weak		RTC_Alarm_IRQHandler
	.thumb_set	RTC_Alarm_IRQHandler, Undefined_Handler

	.word		CEC_IRQHandler
	.weak		CEC_IRQHandler
	.thumb_set	CEC_IRQHandler, Undefined_Handler

	.word		TIM12_IRQHandler
	.weak		TIM12_IRQHandler
	.thumb_set	TIM12_IRQHandler, Undefined_Handler

	/*---------------*/
	/* offset 0x00F0 */
	/*---------------*/
	.word		TIM13_IRQHandler
	.weak		TIM13_IRQHandler
	.thumb_set	TIM13_IRQHandler, Undefined_Handler

	.word		TIM14_IRQHandler
	.weak		TIM14_IRQHandler
	.thumb_set	TIM14_IRQHandler, Undefined_Handler

	.word		0

	.word		0

	/*---------------*/
	/* offset 0x0100 */
	/*---------------*/
	.word		0

	.word		0

	.word		TIM5_IRQHandler
	.weak		TIM5_IRQHandler
	.thumb_set	TIM5_IRQHandler, Undefined_Handler

	.word		SPI3_IRQHandler
	.weak		SPI3_IRQHandler
	.thumb_set	SPI3_IRQHandler, Undefined_Handler

	/*---------------*/
	/* offset 0x0110 */
	/*---------------*/
	.word		0

	.word		0

	.word		TIM6_DAC1_IRQHandler
	.weak		TIM6_DAC1_IRQHandler
	.thumb_set	TIM6_DAC1_IRQHandler, Undefined_Handler

	.word		TIM7_IRQHandler
	.weak		TIM7_IRQHandler
	.thumb_set	TIM7_IRQHandler, Undefined_Handler

	/*---------------*/
	/* offset 0x0120 */
	/*---------------*/
	.word		DMA2_Channel1_IRQHandler
	.weak		DMA2_Channel1_IRQHandler
	.thumb_set	DMA2_Channel1_IRQHandler, Undefined_Handler

	.word		DMA2_Channel2_IRQHandler
	.weak		DMA2_Channel2_IRQHandler
	.thumb_set	DMA2_Channel2_IRQHandler, Undefined_Handler

	.word		DMA2_Channel3_IRQHandler
	.weak		DMA2_Channel3_IRQHandler
	.thumb_set	DMA2_Channel3_IRQHandler, Undefined_Handler

	.word		DMA2_Channel4_IRQHandler
	.weak		DMA2_Channel4_IRQHandler
	.thumb_set	DMA2_Channel4_IRQHandler, Undefined_Handler

	/*---------------*/
	/* offset 0x0130 */
	/*---------------*/
	.word		DMA2_Channel5_IRQHandler
	.weak		DMA2_Channel5_IRQHandler
	.thumb_set	DMA2_Channel5_IRQHandler, Undefined_Handler

	.word		SDADC1_IRQHandler
	.weak		SDADC1_IRQHandler
	.thumb_set	SDADC1_IRQHandler, Undefined_Handler	

	.word		SDADC2_IRQHandler
	.weak		SDADC2_IRQHandler
	.thumb_set	SDADC2_IRQHandler, Undefined_Handler	

	.word		SDADC3_IRQHandler
	.weak		SDADC3_IRQHandler
	.thumb_set	SDADC3_IRQHandler, Undefined_Handler	

	/*---------------*/
	/* offset 0x0140 */
	/*---------------*/
	.word		COMP_IRQHandler
	.weak		COMP_IRQHandler
	.thumb_set	COMP_IRQHandler, Undefined_Handler	

	.word		0

	.word		0

	.word		0

	/*---------------*/
	/* offset 0x0150 */
	/*---------------*/
	.word		0

	.word		0

	.word		0

	.word		0

	/*---------------*/
	/* offset 0x0160 */
	/*---------------*/
	.word		0

	.word		0

	.word		USB_HP_IRQHandler
	.weak		USB_HP_IRQHandler
	.thumb_set	USB_HP_IRQHandler, Undefined_Handler

	.word		USB_LP_IRQHandler
	.weak		USB_LP_IRQHandler
	.thumb_set	USB_LP_IRQHandler, Undefined_Handler

	/*---------------*/
	/* offset 0x0170 */
	/*---------------*/
	.word		USBWakeUp_IRQHandler
	.weak		USBWakeUp_IRQHandler
	.thumb_set	USBWakeUp_IRQHandler, Undefined_Handler

	.word		0

	.word		TIM19_IRQHandler
	.weak		TIM19_IRQHandler
	.thumb_set	TIM19_IRQHandler, Undefined_Handler

	.word		0

	/*---------------*/
	/* offset 0x0180 */
	/*---------------*/
	.word		0

	.word		FPU_IRQHandler
	.weak		FPU_IRQHandler
	.thumb_set	FPU_IRQHandler, Undefined_Handler

	.size VectTable, . - VectTable


	/* Define the handler to which all of the above .thumb_set refer.
	   Note that it must be in this file, otherwise the handler names above
	   will not get recorded in the symbol table. And that will
	   prevent another definition from overriding the vector table entry.
	   Unfortunately, making the symbol for this function .weak doesn't work.
	   That is, the vector table entry still points here even if overridden.
	   Keep this symbol .global. Otherwise the label used for it in the
	   listing file will be the name above that comes first alphabetically. */
	.func	Undefined_Handler
	.global	Undefined_Handler
	.thumb_func

Undefined_Handler:
		b       Default_Handler

	.endfunc


	/* Define the default undefined handler that can be overridden.
	   Note that the section name needs to be unique in whatever file it resides.
	   Otherwise when it is overriden the linker won't remove it completely. */

	.section .text.Default_Handler

	.func	Default_Handler
	.weak	Default_Handler
	.thumb_func

Default_Handler:
		b.n     .

	.endfunc


	/* The following section is needed by the CLang (LLVM) compiler
	   and will simply be discarded by the linker if using the GCC compiler */

	.section .text.aeabi_memset

	.func	__aeabi_memset
	.global	__aeabi_memset
	.thumb_func

__aeabi_memset:
		cbz.n	r1, 1f
	0:	subs	r1, #1
		strb	r2, [r0, r1]
		bne.n	0b
	1:	bx	lr

	.endfunc
